#include "Vram.h"
#include "VVram.h"
#include "Sprite.h"

constexpr byte InvalidY = 0xff;

struct Sprite {
    byte x, y;
    byte oldX, oldY;
    byte[4] chars;
};

Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> pSprite;
    for (pSprite : Sprites) {
        pSprite->y = InvalidY;
        pSprite->oldY = InvalidY;
    }
}


void ShowSprite(byte index, byte x, byte y, ptr<byte> pChars)
{
    ptr<Sprite> pSprite;
    ptr<byte> p;
    pSprite = Sprites + index;
    pSprite->x = x;
    pSprite->y = y;
    p = pSprite->chars;
    repeat (4) {
        *p = *pChars;
        ++p;
        ++pChars;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> pSprite;
    pSprite = Sprites + index;
    pSprite->y = InvalidY;
}

void EraseSprites() 
{
    ptr<Sprite> pSprite;
    byte index;
    index = 0;
    for (pSprite : Sprites) {
        if (pSprite->oldY != InvalidY) {
            word offset;
            ptr<byte> pFront, pBack;
            byte y;
            y = pSprite->oldY;
            offset = VVramOffset(pSprite->oldX, y);
            pFront = VVramFront + offset;
            pBack = VVramBack + offset;
            pFront[0] = pBack[0];
            if (index < Sprite_FighterBullet || index >= Sprite_Item) {
                pFront[1] = pBack[1];
                if (y < VVramHeight - 1) {
                    pFront[VVramWidth] = pBack[VVramWidth];
                    pFront[VVramWidth + 1] = pBack[VVramWidth + 1];
                }
            }
        }
        ++index;
    }
}


void DrawSprites()
{
    ptr<Sprite> pSprite;
    byte index;
    index = 0;
    for (pSprite : Sprites) {
        if (pSprite->y != InvalidY) {
            ptr<byte> pFront, pChars;
            byte y;
            y = pSprite->y;
            pFront = VVramFront + VVramOffset(pSprite->x, y);
            pChars = pSprite->chars;
            pFront[0] = *pChars; 
            if (index < Sprite_FighterBullet || index >= Sprite_Item) {
                ++pChars; pFront[1] = *pChars;
                if (y < VVramHeight - 1) {
                    ++pChars; pFront[VVramWidth] = *pChars;
                    ++pChars; pFront[VVramWidth + 1] = *pChars;
                }
            }
        }
        pSprite->oldX = pSprite->x;
        pSprite->oldY = pSprite->y;
        ++index;
    }
}
